

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>How to configure pywws to post messages to Twitter &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="User guides" href="index.html" />
    <link rel="next" title="How to make a language file for pywws" href="language.html" />
    <link rel="prev" title="How to set up ‘live’ logging with pywws" href="livelogging.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="language.html" title="How to make a language file for pywws"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="livelogging.html" title="How to set up ‘live’ logging with pywws"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">User guides</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="how-to-configure-pywws-to-post-messages-to-twitter">
<h1>How to configure pywws to post messages to Twitter<a class="headerlink" href="#how-to-configure-pywws-to-post-messages-to-twitter" title="Permalink to this headline">¶</a></h1>
<ol class="arabic">
<li><p class="first">Install dependencies.</p>
<ul class="simple">
<li>Python 2.5+ - <a class="reference external" href="http://python.org/">http://python.org/</a> (Note: Python 3 is not supported.)</li>
<li>tweepy - <a class="reference external" href="http://code.google.com/p/tweepy/">http://code.google.com/p/tweepy/</a></li>
<li>simplejson - <a class="reference external" href="http://pypi.python.org/pypi/simplejson/">http://pypi.python.org/pypi/simplejson/</a></li>
</ul>
<p>Note that simplejson is included in Python 2.6+</p>
</li>
<li><p class="first">Create a Twitter account.</p>
<p>You could post weather updates to your &#8216;normal&#8217; Twitter account, but I think it&#8217;s better to have a separate account just for weather reports. This could be useful to someone who lives in your area, but doesn&#8217;t want to know what you had for breakfast.</p>
</li>
<li><p class="first">Authorise pywws to post to your Twitter account.</p>
<p>Make sure no other pywws software is running, then run the <a class="reference internal" href="../api/TwitterAuth.html#module-TwitterAuth"><tt class="xref py py-mod docutils literal"><span class="pre">TwitterAuth</span></tt></a> program:</p>
<div class="highlight-python"><pre>python TwitterAuth.py /data/weather</pre>
</div>
<p>(Replace <tt class="docutils literal"><span class="pre">/data/weather</span></tt> with your data directory.)</p>
<p>This will open a web browser window (or give you a URL to copy to your web browser) where you can log in to your Twitter account and authorise pywws to post. Your web browser will then show a 7 digit number which you need to copy to the <a class="reference internal" href="../api/TwitterAuth.html#module-TwitterAuth"><tt class="xref py py-mod docutils literal"><span class="pre">TwitterAuth</span></tt></a> program. If successful, your weather.ini file will now have a <tt class="docutils literal"><span class="pre">[twitter]</span></tt> section with <tt class="docutils literal"><span class="pre">secret</span></tt> and <tt class="docutils literal"><span class="pre">key</span></tt> entries. (Don&#8217;t disclose these to anyone else.)</p>
</li>
<li><p class="first">Add location data (optional).</p>
<p>Edit your weather.ini file and add <tt class="docutils literal"><span class="pre">latitude</span></tt> and <tt class="docutils literal"><span class="pre">longitude</span></tt> entries to the <tt class="docutils literal"><span class="pre">[twitter]</span></tt> section. For example:</p>
<div class="highlight-python"><div class="highlight"><pre><span class="p">[</span><span class="n">twitter</span><span class="p">]</span>
<span class="n">secret</span> <span class="o">=</span> <span class="n">xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</span>
<span class="n">key</span> <span class="o">=</span> <span class="n">xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx</span>
<span class="n">latitude</span> <span class="o">=</span> <span class="mf">51.501</span>
<span class="n">longitude</span> <span class="o">=</span> <span class="o">-</span><span class="mf">0.142</span>
</pre></div>
</div>
</li>
<li><p class="first">Create a template.</p>
<p>Twitter messages are generated using a template, just like creating files to upload to a website. Copy the example template &#8216;tweet.txt&#8217; to your template directory, then test it:</p>
<div class="highlight-python"><pre>python pywws/Template.py /data/weather ~/weather/templates/tweet.txt tweet.txt
cat tweet.txt</pre>
</div>
<p>(Replace <tt class="docutils literal"><span class="pre">/data/weather</span></tt> and <tt class="docutils literal"><span class="pre">~/weather/templates</span></tt> with your data and template directories.) If you need to change the template (e.g. to change the units or language used) you can edit it now or later.</p>
</li>
<li><p class="first">Post your first weather Tweet.</p>
<p>Now everything is prepared for <a class="reference internal" href="../api/pywws.ToTwitter.html#module-pywws.ToTwitter"><tt class="xref py py-mod docutils literal"><span class="pre">pywws.ToTwitter</span></tt></a> to be run:</p>
<div class="highlight-python"><pre>python pywws/ToTwitter.py /data/weather tweet.txt</pre>
</div>
<p>If this works, your new Twitter account will have posted its first weather report. (You should delete the tweet.txt file now.)</p>
</li>
<li><p class="first">Add Twitter updates to your hourly tasks.</p>
<p>Edit your weather.ini file and edit the <tt class="docutils literal"><span class="pre">[hourly]</span></tt> section. For example:</p>
<div class="highlight-python"><div class="highlight"><pre><span class="p">[</span><span class="n">hourly</span><span class="p">]</span>
<span class="n">services</span> <span class="o">=</span> <span class="p">[]</span>
<span class="n">twitter</span> <span class="o">=</span> <span class="p">[</span><span class="s">&#39;tweet.txt&#39;</span><span class="p">]</span>
<span class="n">plot</span> <span class="o">=</span> <span class="p">[</span><span class="s">&#39;7days.png.xml&#39;</span><span class="p">,</span> <span class="s">&#39;24hrs.png.xml&#39;</span><span class="p">,</span> <span class="s">&#39;rose_12hrs.png.xml&#39;</span><span class="p">]</span>
<span class="n">text</span> <span class="o">=</span> <span class="p">[</span><span class="s">&#39;24hrs.txt&#39;</span><span class="p">,</span> <span class="s">&#39;6hrs.txt&#39;</span><span class="p">,</span> <span class="s">&#39;7days.txt&#39;</span><span class="p">,</span> <span class="s">&#39;allmonths.txt &#39;</span><span class="p">]</span>
</pre></div>
</div>
<p>You could change the <tt class="docutils literal"><span class="pre">[logged]</span></tt>, <tt class="docutils literal"><span class="pre">[12</span> <span class="pre">hourly]</span></tt> or <tt class="docutils literal"><span class="pre">[daily]</span></tt> sections instead, but I think <tt class="docutils literal"><span class="pre">[hourly]</span></tt> is most appropriate for Twitter updates.</p>
<p>Comments or questions? Please subscribe to the pywws mailing list <a class="reference external" href="http://groups.google.com/group/pywws">http://groups.google.com/group/pywws</a> and let us know.</p>
</li>
</ol>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="livelogging.html"
                        title="previous chapter">How to set up &#8216;live&#8217; logging with pywws</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="language.html"
                        title="next chapter">How to make a language file for pywws</a></p>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="language.html" title="How to make a language file for pywws"
             >next</a> |</li>
        <li class="right" >
          <a href="livelogging.html" title="How to set up ‘live’ logging with pywws"
             >previous</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >User guides</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>